<?php
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *                                   ATTENTION!
 * If you see this message in your browser (Internet Explorer, Mozilla Firefox, Google Chrome, etc.)
 * this means that PHP is not properly installed on your web server. Please refer to the PHP manual
 * for more details: http://php.net/manual/install.php 
 *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 */

    include_once dirname(__FILE__) . '/components/startup.php';
    include_once dirname(__FILE__) . '/components/application.php';
    include_once dirname(__FILE__) . '/' . 'authorization.php';


    include_once dirname(__FILE__) . '/' . 'database_engine/pgsql_engine.php';
    include_once dirname(__FILE__) . '/' . 'components/page/page_includes.php';

    function GetConnectionOptions()
    {
        $result = GetGlobalConnectionOptions();
        $result['client_encoding'] = 'utf8';
        GetApplication()->GetUserAuthentication()->applyIdentityToConnectionOptions($result);
        return $result;
    }

    
    
    
    // OnBeforePageExecute event handler
    
    
    
    class public_activity_edm_resultPage extends Page
    {
        protected function DoBeforeCreate()
        {
            $this->SetTitle('');
            $this->SetMenuLabel('Logistik Meldung Basis');
            $this->SetHeader(GetPagesHeader());
            $this->SetFooter(GetPagesFooter());
    
            $this->dataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."activity_edm_result"');
            $this->dataset->addFields(
                array(
                    new StringField('period', true),
                    new IntegerField('cfg_rule', false, true),
                    new StringField('action_type', true),
                    new StringField('waste_gtin', true),
                    new StringField('origin_gln', true),
                    new StringField('disposition_gln', true),
                    new IntegerField('quantity', false, true),
                    new StringField('c_name'),
                    new StringField('c_street'),
                    new StringField('c_street_extension'),
                    new StringField('c_country'),
                    new StringField('c_zip'),
                    new StringField('c_city')
                )
            );
            $this->dataset->AddLookupField('cfg_rule', 'public.tariff_edm_config', new IntegerField('id'), new IntegerField('id', false, false, false, false, 'LA1', 'LT1'), 'LT1');
            $this->dataset->AddLookupField('action_type', 'public.tariff_edm_activity_types', new StringField('activity_type'), new StringField('description', false, false, false, false, 'LA2', 'LT2'), 'LT2');
            $this->dataset->AddLookupField('waste_gtin', 'public.qwaste_catalog', new StringField('gtin'), new StringField('selector', false, false, false, false, 'LA3', 'LT3'), 'LT3');
            $this->dataset->AddLookupField('origin_gln', 'public.contact_edm_gln', new StringField('gln'), new StringField('description', false, false, false, false, 'LA4', 'LT4'), 'LT4');
            $this->dataset->AddLookupField('disposition_gln', 'public.contact_edm_gln', new StringField('gln'), new StringField('description', false, false, false, false, 'LA5', 'LT5'), 'LT5');
        }
    
        protected function DoPrepare() {
    
        }
    
        protected function CreatePageNavigator()
        {
            $result = new CompositePageNavigator($this);
            
            $partitionNavigator = new PageNavigator('pnav', $this, $this->dataset);
            $partitionNavigator->SetRowsPerPage(10);
            $result->AddPageNavigator($partitionNavigator);
            
            return $result;
        }
    
        protected function CreateRssGenerator()
        {
            return null;
        }
    
        protected function setupCharts()
        {
    
        }
    
        protected function getFiltersColumns()
        {
            return array(
                new FilterColumn($this->dataset, 'period', 'period', 'Periode'),
                new FilterColumn($this->dataset, 'cfg_rule', 'LA1', 'Regel'),
                new FilterColumn($this->dataset, 'action_type', 'LA2', 'Typ'),
                new FilterColumn($this->dataset, 'waste_gtin', 'LA3', 'Abfall GTIN'),
                new FilterColumn($this->dataset, 'origin_gln', 'LA4', 'Herkunft GLN'),
                new FilterColumn($this->dataset, 'disposition_gln', 'LA5', 'Verbleib GLN'),
                new FilterColumn($this->dataset, 'quantity', 'quantity', 'Menge'),
                new FilterColumn($this->dataset, 'c_name', 'c_name', 'Name'),
                new FilterColumn($this->dataset, 'c_street', 'c_street', 'Straße'),
                new FilterColumn($this->dataset, 'c_street_extension', 'c_street_extension', 'Straße Zusatz'),
                new FilterColumn($this->dataset, 'c_country', 'c_country', 'Land'),
                new FilterColumn($this->dataset, 'c_zip', 'c_zip', 'PLZ'),
                new FilterColumn($this->dataset, 'c_city', 'c_city', 'Stadt')
            );
        }
    
        protected function setupQuickFilter(QuickFilter $quickFilter, FixedKeysArray $columns)
        {
            $quickFilter
                ->addColumn($columns['period'])
                ->addColumn($columns['cfg_rule'])
                ->addColumn($columns['action_type'])
                ->addColumn($columns['waste_gtin'])
                ->addColumn($columns['origin_gln'])
                ->addColumn($columns['disposition_gln'])
                ->addColumn($columns['quantity'])
                ->addColumn($columns['c_name'])
                ->addColumn($columns['c_street'])
                ->addColumn($columns['c_country'])
                ->addColumn($columns['c_zip'])
                ->addColumn($columns['c_city']);
        }
    
        protected function setupColumnFilter(ColumnFilter $columnFilter)
        {
            $columnFilter
                ->setOptionsFor('period')
                ->setOptionsFor('cfg_rule')
                ->setOptionsFor('action_type')
                ->setOptionsFor('waste_gtin')
                ->setOptionsFor('origin_gln')
                ->setOptionsFor('disposition_gln')
                ->setOptionsFor('c_name')
                ->setOptionsFor('c_street')
                ->setOptionsFor('c_country')
                ->setOptionsFor('c_zip')
                ->setOptionsFor('c_city');
        }
    
        protected function setupFilterBuilder(FilterBuilder $filterBuilder, FixedKeysArray $columns)
        {
            $main_editor = new TextEdit('period_edit');
            
            $filterBuilder->addColumn(
                $columns['period'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new DynamicCombobox('cfg_rule_edit', $this->CreateLinkBuilder());
            $main_editor->setAllowClear(true);
            $main_editor->setMinimumInputLength(0);
            $main_editor->SetAllowNullValue(false);
            $main_editor->SetHandlerName('filter_builder_public_activity_edm_result_cfg_rule_search');
            
            $multi_value_select_editor = new RemoteMultiValueSelect('cfg_rule', $this->CreateLinkBuilder());
            $multi_value_select_editor->SetHandlerName('filter_builder_public_activity_edm_result_cfg_rule_search');
            
            $filterBuilder->addColumn(
                $columns['cfg_rule'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::IN => $multi_value_select_editor,
                    FilterConditionOperator::NOT_IN => $multi_value_select_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new DynamicCombobox('action_type_edit', $this->CreateLinkBuilder());
            $main_editor->setAllowClear(true);
            $main_editor->setMinimumInputLength(0);
            $main_editor->SetAllowNullValue(false);
            $main_editor->SetHandlerName('filter_builder_public_activity_edm_result_action_type_search');
            
            $multi_value_select_editor = new RemoteMultiValueSelect('action_type', $this->CreateLinkBuilder());
            $multi_value_select_editor->SetHandlerName('filter_builder_public_activity_edm_result_action_type_search');
            
            $text_editor = new TextEdit('action_type');
            
            $filterBuilder->addColumn(
                $columns['action_type'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $text_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $text_editor,
                    FilterConditionOperator::BEGINS_WITH => $text_editor,
                    FilterConditionOperator::ENDS_WITH => $text_editor,
                    FilterConditionOperator::IS_LIKE => $text_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $text_editor,
                    FilterConditionOperator::IN => $multi_value_select_editor,
                    FilterConditionOperator::NOT_IN => $multi_value_select_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new DynamicCombobox('waste_gtin_edit', $this->CreateLinkBuilder());
            $main_editor->setAllowClear(true);
            $main_editor->setMinimumInputLength(0);
            $main_editor->SetAllowNullValue(false);
            $main_editor->SetHandlerName('filter_builder_public_activity_edm_result_waste_gtin_search');
            
            $multi_value_select_editor = new RemoteMultiValueSelect('waste_gtin', $this->CreateLinkBuilder());
            $multi_value_select_editor->SetHandlerName('filter_builder_public_activity_edm_result_waste_gtin_search');
            
            $text_editor = new TextEdit('waste_gtin');
            
            $filterBuilder->addColumn(
                $columns['waste_gtin'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $text_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $text_editor,
                    FilterConditionOperator::BEGINS_WITH => $text_editor,
                    FilterConditionOperator::ENDS_WITH => $text_editor,
                    FilterConditionOperator::IS_LIKE => $text_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $text_editor,
                    FilterConditionOperator::IN => $multi_value_select_editor,
                    FilterConditionOperator::NOT_IN => $multi_value_select_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new DynamicCombobox('origin_gln_edit', $this->CreateLinkBuilder());
            $main_editor->setAllowClear(true);
            $main_editor->setMinimumInputLength(0);
            $main_editor->SetAllowNullValue(false);
            $main_editor->SetHandlerName('filter_builder_public_activity_edm_result_origin_gln_search');
            
            $multi_value_select_editor = new RemoteMultiValueSelect('origin_gln', $this->CreateLinkBuilder());
            $multi_value_select_editor->SetHandlerName('filter_builder_public_activity_edm_result_origin_gln_search');
            
            $text_editor = new TextEdit('origin_gln');
            
            $filterBuilder->addColumn(
                $columns['origin_gln'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $text_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $text_editor,
                    FilterConditionOperator::BEGINS_WITH => $text_editor,
                    FilterConditionOperator::ENDS_WITH => $text_editor,
                    FilterConditionOperator::IS_LIKE => $text_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $text_editor,
                    FilterConditionOperator::IN => $multi_value_select_editor,
                    FilterConditionOperator::NOT_IN => $multi_value_select_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new DynamicCombobox('disposition_gln_edit', $this->CreateLinkBuilder());
            $main_editor->setAllowClear(true);
            $main_editor->setMinimumInputLength(0);
            $main_editor->SetAllowNullValue(false);
            $main_editor->SetHandlerName('filter_builder_public_activity_edm_result_disposition_gln_search');
            
            $multi_value_select_editor = new RemoteMultiValueSelect('disposition_gln', $this->CreateLinkBuilder());
            $multi_value_select_editor->SetHandlerName('filter_builder_public_activity_edm_result_disposition_gln_search');
            
            $text_editor = new TextEdit('disposition_gln');
            
            $filterBuilder->addColumn(
                $columns['disposition_gln'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $text_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $text_editor,
                    FilterConditionOperator::BEGINS_WITH => $text_editor,
                    FilterConditionOperator::ENDS_WITH => $text_editor,
                    FilterConditionOperator::IS_LIKE => $text_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $text_editor,
                    FilterConditionOperator::IN => $multi_value_select_editor,
                    FilterConditionOperator::NOT_IN => $multi_value_select_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('quantity_edit');
            
            $filterBuilder->addColumn(
                $columns['quantity'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('c_name_edit');
            
            $filterBuilder->addColumn(
                $columns['c_name'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('c_street_edit');
            
            $filterBuilder->addColumn(
                $columns['c_street'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('c_country_edit');
            
            $filterBuilder->addColumn(
                $columns['c_country'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('c_zip_edit');
            
            $filterBuilder->addColumn(
                $columns['c_zip'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
            
            $main_editor = new TextEdit('c_city_edit');
            
            $filterBuilder->addColumn(
                $columns['c_city'],
                array(
                    FilterConditionOperator::EQUALS => $main_editor,
                    FilterConditionOperator::DOES_NOT_EQUAL => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN => $main_editor,
                    FilterConditionOperator::IS_GREATER_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN => $main_editor,
                    FilterConditionOperator::IS_LESS_THAN_OR_EQUAL_TO => $main_editor,
                    FilterConditionOperator::IS_BETWEEN => $main_editor,
                    FilterConditionOperator::IS_NOT_BETWEEN => $main_editor,
                    FilterConditionOperator::CONTAINS => $main_editor,
                    FilterConditionOperator::DOES_NOT_CONTAIN => $main_editor,
                    FilterConditionOperator::BEGINS_WITH => $main_editor,
                    FilterConditionOperator::ENDS_WITH => $main_editor,
                    FilterConditionOperator::IS_LIKE => $main_editor,
                    FilterConditionOperator::IS_NOT_LIKE => $main_editor,
                    FilterConditionOperator::IS_BLANK => null,
                    FilterConditionOperator::IS_NOT_BLANK => null
                )
            );
        }
    
        protected function AddOperationsColumns(Grid $grid)
        {
    
        }
    
        protected function AddFieldColumns(Grid $grid, $withDetails = true)
        {
            //
            // View column for period field
            //
            $column = new TextViewColumn('period', 'period', 'Periode', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_period_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for id field
            //
            $column = new StringTransformViewColumn('cfg_rule', 'LA1', 'Regel', $this->dataset);
            $column->SetOrderable(true);
            $column->setStringTransformFunction('');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('action_type', 'LA2', 'Typ', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_LA2_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('waste_gtin', 'LA3', 'Abfall GTIN', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_LA3_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('origin_gln', 'LA4', 'Herkunft GLN', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_LA4_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('disposition_gln', 'LA5', 'Verbleib GLN', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_LA5_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for quantity field
            //
            $column = new NumberViewColumn('quantity', 'quantity', 'Menge', $this->dataset);
            $column->SetOrderable(true);
            $column->setNumberAfterDecimal(0);
            $column->setThousandsSeparator('.');
            $column->setDecimalSeparator(',');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for c_name field
            //
            $column = new TextViewColumn('c_name', 'c_name', 'Name', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_c_name_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for c_street field
            //
            $column = new TextViewColumn('c_street', 'c_street', 'Straße', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_c_street_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for c_country field
            //
            $column = new TextViewColumn('c_country', 'c_country', 'Land', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_c_country_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for c_zip field
            //
            $column = new TextViewColumn('c_zip', 'c_zip', 'PLZ', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_c_zip_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
            
            //
            // View column for c_city field
            //
            $column = new TextViewColumn('c_city', 'c_city', 'Stadt', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_c_city_handler_list');
            $column->setMinimalVisibility(ColumnVisibility::PHONE);
            $column->SetDescription('');
            $column->SetFixedWidth(null);
            $grid->AddViewColumn($column);
        }
    
        protected function AddSingleRecordViewColumns(Grid $grid)
        {
            //
            // View column for period field
            //
            $column = new TextViewColumn('period', 'period', 'Periode', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_period_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for id field
            //
            $column = new StringTransformViewColumn('cfg_rule', 'LA1', 'Regel', $this->dataset);
            $column->SetOrderable(true);
            $column->setStringTransformFunction('');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('action_type', 'LA2', 'Typ', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_LA2_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('waste_gtin', 'LA3', 'Abfall GTIN', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_LA3_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('origin_gln', 'LA4', 'Herkunft GLN', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_LA4_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('disposition_gln', 'LA5', 'Verbleib GLN', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_LA5_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for quantity field
            //
            $column = new NumberViewColumn('quantity', 'quantity', 'Menge', $this->dataset);
            $column->SetOrderable(true);
            $column->setNumberAfterDecimal(0);
            $column->setThousandsSeparator('.');
            $column->setDecimalSeparator(',');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for c_name field
            //
            $column = new TextViewColumn('c_name', 'c_name', 'Name', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_c_name_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for c_street field
            //
            $column = new TextViewColumn('c_street', 'c_street', 'Straße', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_c_street_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for c_country field
            //
            $column = new TextViewColumn('c_country', 'c_country', 'Land', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_c_country_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for c_zip field
            //
            $column = new TextViewColumn('c_zip', 'c_zip', 'PLZ', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_c_zip_handler_view');
            $grid->AddSingleRecordViewColumn($column);
            
            //
            // View column for c_city field
            //
            $column = new TextViewColumn('c_city', 'c_city', 'Stadt', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_c_city_handler_view');
            $grid->AddSingleRecordViewColumn($column);
        }
    
        protected function AddEditColumns(Grid $grid)
        {
            //
            // Edit column for period field
            //
            $editor = new TextEdit('period_edit');
            $editColumn = new CustomEditColumn('Periode', 'period', $editor, $this->dataset);
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for cfg_rule field
            //
            $editor = new DynamicCombobox('cfg_rule_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."tariff_edm_config"');
            $lookupDataset->addFields(
                array(
                    new IntegerField('id', true, true, true),
                    new StringField('period'),
                    new StringField('action_type'),
                    new StringField('data_type'),
                    new StringField('inclusion'),
                    new StringField('exclusion'),
                    new StringField('tariff'),
                    new IntegerField('quantity_percent'),
                    new IntegerField('quantity'),
                    new StringField('remark'),
                    new StringField('origin_gln'),
                    new StringField('disposition_gln'),
                    new StringField('waste_gtin'),
                    new IntegerField('multiply'),
                    new StringField('o_street'),
                    new StringField('o_street_extension'),
                    new StringField('o_country'),
                    new StringField('o_zip'),
                    new StringField('o_city'),
                    new StringField('d_street'),
                    new StringField('d_street_extension'),
                    new StringField('d_country'),
                    new StringField('d_zip'),
                    new StringField('d_city'),
                    new StringField('o_name'),
                    new StringField('d_name'),
                    new StringField('report_gln'),
                    new StringField('zip_inclusion'),
                    new StringField('zip_exclusion'),
                    new StringField('cat_inclusion'),
                    new StringField('cat_exclusion')
                )
            );
            $lookupDataset->setOrderByField('id', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Regel', 'cfg_rule', 'LA1', 'edit_public_activity_edm_result_cfg_rule_search', $editor, $this->dataset, $lookupDataset, 'id', 'id', '');
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for action_type field
            //
            $editor = new DynamicCombobox('action_type_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."tariff_edm_activity_types"');
            $lookupDataset->addFields(
                array(
                    new StringField('activity_type', true, true),
                    new StringField('description')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Typ', 'action_type', 'LA2', 'edit_public_activity_edm_result_action_type_search', $editor, $this->dataset, $lookupDataset, 'activity_type', 'description', '');
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for waste_gtin field
            //
            $editor = new DynamicCombobox('waste_gtin_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qwaste_catalog"');
            $lookupDataset->addFields(
                array(
                    new StringField('gtin'),
                    new StringField('selector')
                )
            );
            $lookupDataset->setOrderByField('selector', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Abfall GTIN', 'waste_gtin', 'LA3', 'edit_public_activity_edm_result_waste_gtin_search', $editor, $this->dataset, $lookupDataset, 'gtin', 'selector', '');
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for origin_gln field
            //
            $editor = new DynamicCombobox('origin_gln_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Herkunft GLN', 'origin_gln', 'LA4', 'edit_public_activity_edm_result_origin_gln_search', $editor, $this->dataset, $lookupDataset, 'gln', 'description', '');
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for disposition_gln field
            //
            $editor = new DynamicCombobox('disposition_gln_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Verbleib GLN', 'disposition_gln', 'LA5', 'edit_public_activity_edm_result_disposition_gln_search', $editor, $this->dataset, $lookupDataset, 'gln', 'description', '');
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for quantity field
            //
            $editor = new TextEdit('quantity_edit');
            $editColumn = new CustomEditColumn('Menge', 'quantity', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for c_name field
            //
            $editor = new TextEdit('c_name_edit');
            $editColumn = new CustomEditColumn('Name', 'c_name', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for c_street field
            //
            $editor = new TextEdit('c_street_edit');
            $editColumn = new CustomEditColumn('Straße', 'c_street', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for c_country field
            //
            $editor = new TextEdit('c_country_edit');
            $editColumn = new CustomEditColumn('Land', 'c_country', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for c_zip field
            //
            $editor = new TextEdit('c_zip_edit');
            $editColumn = new CustomEditColumn('PLZ', 'c_zip', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
            
            //
            // Edit column for c_city field
            //
            $editor = new TextEdit('c_city_edit');
            $editColumn = new CustomEditColumn('Stadt', 'c_city', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddEditColumn($editColumn);
        }
    
        protected function AddMultiEditColumns(Grid $grid)
        {
            //
            // Edit column for period field
            //
            $editor = new TextEdit('period_edit');
            $editColumn = new CustomEditColumn('Periode', 'period', $editor, $this->dataset);
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for cfg_rule field
            //
            $editor = new DynamicCombobox('cfg_rule_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."tariff_edm_config"');
            $lookupDataset->addFields(
                array(
                    new IntegerField('id', true, true, true),
                    new StringField('period'),
                    new StringField('action_type'),
                    new StringField('data_type'),
                    new StringField('inclusion'),
                    new StringField('exclusion'),
                    new StringField('tariff'),
                    new IntegerField('quantity_percent'),
                    new IntegerField('quantity'),
                    new StringField('remark'),
                    new StringField('origin_gln'),
                    new StringField('disposition_gln'),
                    new StringField('waste_gtin'),
                    new IntegerField('multiply'),
                    new StringField('o_street'),
                    new StringField('o_street_extension'),
                    new StringField('o_country'),
                    new StringField('o_zip'),
                    new StringField('o_city'),
                    new StringField('d_street'),
                    new StringField('d_street_extension'),
                    new StringField('d_country'),
                    new StringField('d_zip'),
                    new StringField('d_city'),
                    new StringField('o_name'),
                    new StringField('d_name'),
                    new StringField('report_gln'),
                    new StringField('zip_inclusion'),
                    new StringField('zip_exclusion'),
                    new StringField('cat_inclusion'),
                    new StringField('cat_exclusion')
                )
            );
            $lookupDataset->setOrderByField('id', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Regel', 'cfg_rule', 'LA1', 'multi_edit_public_activity_edm_result_cfg_rule_search', $editor, $this->dataset, $lookupDataset, 'id', 'id', '');
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for action_type field
            //
            $editor = new DynamicCombobox('action_type_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."tariff_edm_activity_types"');
            $lookupDataset->addFields(
                array(
                    new StringField('activity_type', true, true),
                    new StringField('description')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Typ', 'action_type', 'LA2', 'multi_edit_public_activity_edm_result_action_type_search', $editor, $this->dataset, $lookupDataset, 'activity_type', 'description', '');
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for waste_gtin field
            //
            $editor = new DynamicCombobox('waste_gtin_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qwaste_catalog"');
            $lookupDataset->addFields(
                array(
                    new StringField('gtin'),
                    new StringField('selector')
                )
            );
            $lookupDataset->setOrderByField('selector', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Abfall GTIN', 'waste_gtin', 'LA3', 'multi_edit_public_activity_edm_result_waste_gtin_search', $editor, $this->dataset, $lookupDataset, 'gtin', 'selector', '');
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for origin_gln field
            //
            $editor = new DynamicCombobox('origin_gln_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Herkunft GLN', 'origin_gln', 'LA4', 'multi_edit_public_activity_edm_result_origin_gln_search', $editor, $this->dataset, $lookupDataset, 'gln', 'description', '');
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for disposition_gln field
            //
            $editor = new DynamicCombobox('disposition_gln_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Verbleib GLN', 'disposition_gln', 'LA5', 'multi_edit_public_activity_edm_result_disposition_gln_search', $editor, $this->dataset, $lookupDataset, 'gln', 'description', '');
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for quantity field
            //
            $editor = new TextEdit('quantity_edit');
            $editColumn = new CustomEditColumn('Menge', 'quantity', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for c_name field
            //
            $editor = new TextEdit('c_name_edit');
            $editColumn = new CustomEditColumn('Name', 'c_name', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for c_street field
            //
            $editor = new TextEdit('c_street_edit');
            $editColumn = new CustomEditColumn('Straße', 'c_street', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for c_country field
            //
            $editor = new TextEdit('c_country_edit');
            $editColumn = new CustomEditColumn('Land', 'c_country', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for c_zip field
            //
            $editor = new TextEdit('c_zip_edit');
            $editColumn = new CustomEditColumn('PLZ', 'c_zip', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
            
            //
            // Edit column for c_city field
            //
            $editor = new TextEdit('c_city_edit');
            $editColumn = new CustomEditColumn('Stadt', 'c_city', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddMultiEditColumn($editColumn);
        }
    
        protected function AddInsertColumns(Grid $grid)
        {
            //
            // Edit column for period field
            //
            $editor = new TextEdit('period_edit');
            $editColumn = new CustomEditColumn('Periode', 'period', $editor, $this->dataset);
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for cfg_rule field
            //
            $editor = new DynamicCombobox('cfg_rule_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."tariff_edm_config"');
            $lookupDataset->addFields(
                array(
                    new IntegerField('id', true, true, true),
                    new StringField('period'),
                    new StringField('action_type'),
                    new StringField('data_type'),
                    new StringField('inclusion'),
                    new StringField('exclusion'),
                    new StringField('tariff'),
                    new IntegerField('quantity_percent'),
                    new IntegerField('quantity'),
                    new StringField('remark'),
                    new StringField('origin_gln'),
                    new StringField('disposition_gln'),
                    new StringField('waste_gtin'),
                    new IntegerField('multiply'),
                    new StringField('o_street'),
                    new StringField('o_street_extension'),
                    new StringField('o_country'),
                    new StringField('o_zip'),
                    new StringField('o_city'),
                    new StringField('d_street'),
                    new StringField('d_street_extension'),
                    new StringField('d_country'),
                    new StringField('d_zip'),
                    new StringField('d_city'),
                    new StringField('o_name'),
                    new StringField('d_name'),
                    new StringField('report_gln'),
                    new StringField('zip_inclusion'),
                    new StringField('zip_exclusion'),
                    new StringField('cat_inclusion'),
                    new StringField('cat_exclusion')
                )
            );
            $lookupDataset->setOrderByField('id', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Regel', 'cfg_rule', 'LA1', 'insert_public_activity_edm_result_cfg_rule_search', $editor, $this->dataset, $lookupDataset, 'id', 'id', '');
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for action_type field
            //
            $editor = new DynamicCombobox('action_type_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."tariff_edm_activity_types"');
            $lookupDataset->addFields(
                array(
                    new StringField('activity_type', true, true),
                    new StringField('description')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Typ', 'action_type', 'LA2', 'insert_public_activity_edm_result_action_type_search', $editor, $this->dataset, $lookupDataset, 'activity_type', 'description', '');
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for waste_gtin field
            //
            $editor = new DynamicCombobox('waste_gtin_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qwaste_catalog"');
            $lookupDataset->addFields(
                array(
                    new StringField('gtin'),
                    new StringField('selector')
                )
            );
            $lookupDataset->setOrderByField('selector', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Abfall GTIN', 'waste_gtin', 'LA3', 'insert_public_activity_edm_result_waste_gtin_search', $editor, $this->dataset, $lookupDataset, 'gtin', 'selector', '');
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for origin_gln field
            //
            $editor = new DynamicCombobox('origin_gln_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Herkunft GLN', 'origin_gln', 'LA4', 'insert_public_activity_edm_result_origin_gln_search', $editor, $this->dataset, $lookupDataset, 'gln', 'description', '');
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for disposition_gln field
            //
            $editor = new DynamicCombobox('disposition_gln_edit', $this->CreateLinkBuilder());
            $editor->setAllowClear(true);
            $editor->setMinimumInputLength(0);
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $editColumn = new DynamicLookupEditColumn('Verbleib GLN', 'disposition_gln', 'LA5', 'insert_public_activity_edm_result_disposition_gln_search', $editor, $this->dataset, $lookupDataset, 'gln', 'description', '');
            $validator = new RequiredValidator(StringUtils::Format($this->GetLocalizerCaptions()->GetMessageString('RequiredValidationMessage'), $editColumn->GetCaption()));
            $editor->GetValidatorCollection()->AddValidator($validator);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for quantity field
            //
            $editor = new TextEdit('quantity_edit');
            $editColumn = new CustomEditColumn('Menge', 'quantity', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for c_name field
            //
            $editor = new TextEdit('c_name_edit');
            $editColumn = new CustomEditColumn('Name', 'c_name', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for c_street field
            //
            $editor = new TextEdit('c_street_edit');
            $editColumn = new CustomEditColumn('Straße', 'c_street', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for c_country field
            //
            $editor = new TextEdit('c_country_edit');
            $editColumn = new CustomEditColumn('Land', 'c_country', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for c_zip field
            //
            $editor = new TextEdit('c_zip_edit');
            $editColumn = new CustomEditColumn('PLZ', 'c_zip', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            
            //
            // Edit column for c_city field
            //
            $editor = new TextEdit('c_city_edit');
            $editColumn = new CustomEditColumn('Stadt', 'c_city', $editor, $this->dataset);
            $editColumn->SetAllowSetToNull(true);
            $this->ApplyCommonColumnEditProperties($editColumn);
            $grid->AddInsertColumn($editColumn);
            $grid->SetShowAddButton(false && $this->GetSecurityInfo()->HasAddGrant());
        }
    
        private function AddMultiUploadColumn(Grid $grid)
        {
    
        }
    
        protected function AddPrintColumns(Grid $grid)
        {
            //
            // View column for period field
            //
            $column = new TextViewColumn('period', 'period', 'Periode', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_period_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for id field
            //
            $column = new StringTransformViewColumn('cfg_rule', 'LA1', 'Regel', $this->dataset);
            $column->SetOrderable(true);
            $column->setStringTransformFunction('');
            $grid->AddPrintColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('action_type', 'LA2', 'Typ', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_LA2_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('waste_gtin', 'LA3', 'Abfall GTIN', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_LA3_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('origin_gln', 'LA4', 'Herkunft GLN', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_LA4_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('disposition_gln', 'LA5', 'Verbleib GLN', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_LA5_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for quantity field
            //
            $column = new NumberViewColumn('quantity', 'quantity', 'Menge', $this->dataset);
            $column->SetOrderable(true);
            $column->setNumberAfterDecimal(0);
            $column->setThousandsSeparator('.');
            $column->setDecimalSeparator(',');
            $grid->AddPrintColumn($column);
            
            //
            // View column for c_name field
            //
            $column = new TextViewColumn('c_name', 'c_name', 'Name', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_c_name_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for c_street field
            //
            $column = new TextViewColumn('c_street', 'c_street', 'Straße', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_c_street_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for c_country field
            //
            $column = new TextViewColumn('c_country', 'c_country', 'Land', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_c_country_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for c_zip field
            //
            $column = new TextViewColumn('c_zip', 'c_zip', 'PLZ', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_c_zip_handler_print');
            $grid->AddPrintColumn($column);
            
            //
            // View column for c_city field
            //
            $column = new TextViewColumn('c_city', 'c_city', 'Stadt', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_c_city_handler_print');
            $grid->AddPrintColumn($column);
        }
    
        protected function AddExportColumns(Grid $grid)
        {
            //
            // View column for period field
            //
            $column = new TextViewColumn('period', 'period', 'Periode', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_period_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for id field
            //
            $column = new StringTransformViewColumn('cfg_rule', 'LA1', 'Regel', $this->dataset);
            $column->SetOrderable(true);
            $column->setStringTransformFunction('');
            $grid->AddExportColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('action_type', 'LA2', 'Typ', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_LA2_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('waste_gtin', 'LA3', 'Abfall GTIN', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_LA3_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('origin_gln', 'LA4', 'Herkunft GLN', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_LA4_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('disposition_gln', 'LA5', 'Verbleib GLN', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_LA5_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for quantity field
            //
            $column = new NumberViewColumn('quantity', 'quantity', 'Menge', $this->dataset);
            $column->SetOrderable(true);
            $column->setNumberAfterDecimal(0);
            $column->setThousandsSeparator('.');
            $column->setDecimalSeparator(',');
            $grid->AddExportColumn($column);
            
            //
            // View column for c_name field
            //
            $column = new TextViewColumn('c_name', 'c_name', 'Name', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_c_name_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for c_street field
            //
            $column = new TextViewColumn('c_street', 'c_street', 'Straße', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_c_street_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for c_country field
            //
            $column = new TextViewColumn('c_country', 'c_country', 'Land', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_c_country_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for c_zip field
            //
            $column = new TextViewColumn('c_zip', 'c_zip', 'PLZ', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_c_zip_handler_export');
            $grid->AddExportColumn($column);
            
            //
            // View column for c_city field
            //
            $column = new TextViewColumn('c_city', 'c_city', 'Stadt', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_c_city_handler_export');
            $grid->AddExportColumn($column);
        }
    
        private function AddCompareColumns(Grid $grid)
        {
            //
            // View column for period field
            //
            $column = new TextViewColumn('period', 'period', 'Periode', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_period_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for id field
            //
            $column = new StringTransformViewColumn('cfg_rule', 'LA1', 'Regel', $this->dataset);
            $column->SetOrderable(true);
            $column->setStringTransformFunction('');
            $grid->AddCompareColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('action_type', 'LA2', 'Typ', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_LA2_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('waste_gtin', 'LA3', 'Abfall GTIN', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_LA3_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('origin_gln', 'LA4', 'Herkunft GLN', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_LA4_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('disposition_gln', 'LA5', 'Verbleib GLN', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_LA5_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for quantity field
            //
            $column = new NumberViewColumn('quantity', 'quantity', 'Menge', $this->dataset);
            $column->SetOrderable(true);
            $column->setNumberAfterDecimal(0);
            $column->setThousandsSeparator('.');
            $column->setDecimalSeparator(',');
            $grid->AddCompareColumn($column);
            
            //
            // View column for c_name field
            //
            $column = new TextViewColumn('c_name', 'c_name', 'Name', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_c_name_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for c_street field
            //
            $column = new TextViewColumn('c_street', 'c_street', 'Straße', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_c_street_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for c_country field
            //
            $column = new TextViewColumn('c_country', 'c_country', 'Land', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_c_country_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for c_zip field
            //
            $column = new TextViewColumn('c_zip', 'c_zip', 'PLZ', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_c_zip_handler_compare');
            $grid->AddCompareColumn($column);
            
            //
            // View column for c_city field
            //
            $column = new TextViewColumn('c_city', 'c_city', 'Stadt', $this->dataset);
            $column->SetOrderable(true);
            $column->SetMaxLength(75);
            $column->SetFullTextWindowHandlerName('public_activity_edm_resultGrid_c_city_handler_compare');
            $grid->AddCompareColumn($column);
        }
    
        private function AddCompareHeaderColumns(Grid $grid)
        {
    
        }
    
        public function GetPageDirection()
        {
            return null;
        }
    
        public function isFilterConditionRequired()
        {
            return true;
        }
    
        protected function ApplyCommonColumnEditProperties(CustomEditColumn $column)
        {
            $column->SetDisplaySetToNullCheckBox(false);
            $column->SetDisplaySetToDefaultCheckBox(false);
    		$column->SetVariableContainer($this->GetColumnVariableContainer());
        }
    
        function GetCustomClientScript()
        {
            return ;
        }
        
        function GetOnPageLoadedClientScript()
        {
            return ;
        }
    
        protected function CreateGrid()
        {
            $result = new Grid($this, $this->dataset);
            if ($this->GetSecurityInfo()->HasDeleteGrant())
               $result->SetAllowDeleteSelected(false);
            else
               $result->SetAllowDeleteSelected(false);   
            
            ApplyCommonPageSettings($this, $result);
            
            $result->SetUseImagesForActions(true);
            $result->SetUseFixedHeader(false);
            $result->SetShowLineNumbers(false);
            $result->SetShowKeyColumnsImagesInHeader(false);
            $result->SetViewMode(ViewMode::TABLE);
            $result->setEnableRuntimeCustomization(true);
            $result->setAllowCompare(true);
            $this->AddCompareHeaderColumns($result);
            $this->AddCompareColumns($result);
            $result->setMultiEditAllowed($this->GetSecurityInfo()->HasEditGrant() && false);
            $result->setTableBordered(false);
            $result->setTableCondensed(false);
            
            $result->SetHighlightRowAtHover(false);
            $result->SetWidth('');
            $this->AddOperationsColumns($result);
            $this->AddFieldColumns($result);
            $this->AddSingleRecordViewColumns($result);
            $this->AddEditColumns($result);
            $this->AddMultiEditColumns($result);
            $this->AddInsertColumns($result);
            $this->AddPrintColumns($result);
            $this->AddExportColumns($result);
            $this->AddMultiUploadColumn($result);
    
    
            $this->SetShowPageList(true);
            $this->SetShowTopPageNavigator(true);
            $this->SetShowBottomPageNavigator(true);
            $this->setPrintListAvailable(true);
            $this->setPrintListRecordAvailable(false);
            $this->setPrintOneRecordAvailable(true);
            $this->setAllowPrintSelectedRecords(true);
            $this->setExportListAvailable(array('pdf', 'excel', 'word', 'xml', 'csv'));
            $this->setExportSelectedRecordsAvailable(array('pdf', 'excel', 'word', 'xml', 'csv'));
            $this->setExportListRecordAvailable(array());
            $this->setExportOneRecordAvailable(array('pdf', 'excel', 'word', 'xml', 'csv'));
    
            return $result;
        }
     
        protected function setClientSideEvents(Grid $grid) {
    
        }
    
        protected function doRegisterHandlers() {
            //
            // View column for period field
            //
            $column = new TextViewColumn('period', 'period', 'Periode', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_resultGrid_period_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('action_type', 'LA2', 'Typ', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_resultGrid_LA2_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('waste_gtin', 'LA3', 'Abfall GTIN', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_resultGrid_LA3_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('origin_gln', 'LA4', 'Herkunft GLN', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_resultGrid_LA4_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('disposition_gln', 'LA5', 'Verbleib GLN', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_resultGrid_LA5_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for c_name field
            //
            $column = new TextViewColumn('c_name', 'c_name', 'Name', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_resultGrid_c_name_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for c_street field
            //
            $column = new TextViewColumn('c_street', 'c_street', 'Straße', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_resultGrid_c_street_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for c_country field
            //
            $column = new TextViewColumn('c_country', 'c_country', 'Land', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_resultGrid_c_country_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for c_zip field
            //
            $column = new TextViewColumn('c_zip', 'c_zip', 'PLZ', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_resultGrid_c_zip_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for c_city field
            //
            $column = new TextViewColumn('c_city', 'c_city', 'Stadt', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_resultGrid_c_city_handler_list', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for period field
            //
            $column = new TextViewColumn('period', 'period', 'Periode', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_resultGrid_period_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('action_type', 'LA2', 'Typ', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_resultGrid_LA2_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('waste_gtin', 'LA3', 'Abfall GTIN', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_resultGrid_LA3_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('origin_gln', 'LA4', 'Herkunft GLN', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_resultGrid_LA4_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('disposition_gln', 'LA5', 'Verbleib GLN', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_resultGrid_LA5_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for c_name field
            //
            $column = new TextViewColumn('c_name', 'c_name', 'Name', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_resultGrid_c_name_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for c_street field
            //
            $column = new TextViewColumn('c_street', 'c_street', 'Straße', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_resultGrid_c_street_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for c_country field
            //
            $column = new TextViewColumn('c_country', 'c_country', 'Land', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_resultGrid_c_country_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for c_zip field
            //
            $column = new TextViewColumn('c_zip', 'c_zip', 'PLZ', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_resultGrid_c_zip_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for c_city field
            //
            $column = new TextViewColumn('c_city', 'c_city', 'Stadt', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_resultGrid_c_city_handler_print', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for period field
            //
            $column = new TextViewColumn('period', 'period', 'Periode', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_resultGrid_period_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('action_type', 'LA2', 'Typ', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_resultGrid_LA2_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('waste_gtin', 'LA3', 'Abfall GTIN', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_resultGrid_LA3_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('origin_gln', 'LA4', 'Herkunft GLN', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_resultGrid_LA4_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('disposition_gln', 'LA5', 'Verbleib GLN', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_resultGrid_LA5_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for c_name field
            //
            $column = new TextViewColumn('c_name', 'c_name', 'Name', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_resultGrid_c_name_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for c_street field
            //
            $column = new TextViewColumn('c_street', 'c_street', 'Straße', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_resultGrid_c_street_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for c_country field
            //
            $column = new TextViewColumn('c_country', 'c_country', 'Land', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_resultGrid_c_country_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for c_zip field
            //
            $column = new TextViewColumn('c_zip', 'c_zip', 'PLZ', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_resultGrid_c_zip_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for c_city field
            //
            $column = new TextViewColumn('c_city', 'c_city', 'Stadt', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_resultGrid_c_city_handler_compare', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."tariff_edm_config"');
            $lookupDataset->addFields(
                array(
                    new IntegerField('id', true, true, true),
                    new StringField('period'),
                    new StringField('action_type'),
                    new StringField('data_type'),
                    new StringField('inclusion'),
                    new StringField('exclusion'),
                    new StringField('tariff'),
                    new IntegerField('quantity_percent'),
                    new IntegerField('quantity'),
                    new StringField('remark'),
                    new StringField('origin_gln'),
                    new StringField('disposition_gln'),
                    new StringField('waste_gtin'),
                    new IntegerField('multiply'),
                    new StringField('o_street'),
                    new StringField('o_street_extension'),
                    new StringField('o_country'),
                    new StringField('o_zip'),
                    new StringField('o_city'),
                    new StringField('d_street'),
                    new StringField('d_street_extension'),
                    new StringField('d_country'),
                    new StringField('d_zip'),
                    new StringField('d_city'),
                    new StringField('o_name'),
                    new StringField('d_name'),
                    new StringField('report_gln'),
                    new StringField('zip_inclusion'),
                    new StringField('zip_exclusion'),
                    new StringField('cat_inclusion'),
                    new StringField('cat_exclusion')
                )
            );
            $lookupDataset->setOrderByField('id', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'insert_public_activity_edm_result_cfg_rule_search', 'id', 'id', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."tariff_edm_activity_types"');
            $lookupDataset->addFields(
                array(
                    new StringField('activity_type', true, true),
                    new StringField('description')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'insert_public_activity_edm_result_action_type_search', 'activity_type', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qwaste_catalog"');
            $lookupDataset->addFields(
                array(
                    new StringField('gtin'),
                    new StringField('selector')
                )
            );
            $lookupDataset->setOrderByField('selector', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'insert_public_activity_edm_result_waste_gtin_search', 'gtin', 'selector', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'insert_public_activity_edm_result_origin_gln_search', 'gln', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'insert_public_activity_edm_result_disposition_gln_search', 'gln', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."tariff_edm_config"');
            $lookupDataset->addFields(
                array(
                    new IntegerField('id', true, true, true),
                    new StringField('period'),
                    new StringField('action_type'),
                    new StringField('data_type'),
                    new StringField('inclusion'),
                    new StringField('exclusion'),
                    new StringField('tariff'),
                    new IntegerField('quantity_percent'),
                    new IntegerField('quantity'),
                    new StringField('remark'),
                    new StringField('origin_gln'),
                    new StringField('disposition_gln'),
                    new StringField('waste_gtin'),
                    new IntegerField('multiply'),
                    new StringField('o_street'),
                    new StringField('o_street_extension'),
                    new StringField('o_country'),
                    new StringField('o_zip'),
                    new StringField('o_city'),
                    new StringField('d_street'),
                    new StringField('d_street_extension'),
                    new StringField('d_country'),
                    new StringField('d_zip'),
                    new StringField('d_city'),
                    new StringField('o_name'),
                    new StringField('d_name'),
                    new StringField('report_gln'),
                    new StringField('zip_inclusion'),
                    new StringField('zip_exclusion'),
                    new StringField('cat_inclusion'),
                    new StringField('cat_exclusion')
                )
            );
            $lookupDataset->setOrderByField('id', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'filter_builder_public_activity_edm_result_cfg_rule_search', 'id', 'id', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."tariff_edm_activity_types"');
            $lookupDataset->addFields(
                array(
                    new StringField('activity_type', true, true),
                    new StringField('description')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'filter_builder_public_activity_edm_result_action_type_search', 'activity_type', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qwaste_catalog"');
            $lookupDataset->addFields(
                array(
                    new StringField('gtin'),
                    new StringField('selector')
                )
            );
            $lookupDataset->setOrderByField('selector', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'filter_builder_public_activity_edm_result_waste_gtin_search', 'gtin', 'selector', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'filter_builder_public_activity_edm_result_origin_gln_search', 'gln', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'filter_builder_public_activity_edm_result_disposition_gln_search', 'gln', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for period field
            //
            $column = new TextViewColumn('period', 'period', 'Periode', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_resultGrid_period_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('action_type', 'LA2', 'Typ', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_resultGrid_LA2_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for selector field
            //
            $column = new TextViewColumn('waste_gtin', 'LA3', 'Abfall GTIN', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_resultGrid_LA3_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('origin_gln', 'LA4', 'Herkunft GLN', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_resultGrid_LA4_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for description field
            //
            $column = new TextViewColumn('disposition_gln', 'LA5', 'Verbleib GLN', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_resultGrid_LA5_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for c_name field
            //
            $column = new TextViewColumn('c_name', 'c_name', 'Name', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_resultGrid_c_name_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for c_street field
            //
            $column = new TextViewColumn('c_street', 'c_street', 'Straße', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_resultGrid_c_street_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for c_country field
            //
            $column = new TextViewColumn('c_country', 'c_country', 'Land', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_resultGrid_c_country_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for c_zip field
            //
            $column = new TextViewColumn('c_zip', 'c_zip', 'PLZ', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_resultGrid_c_zip_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            //
            // View column for c_city field
            //
            $column = new TextViewColumn('c_city', 'c_city', 'Stadt', $this->dataset);
            $column->SetOrderable(true);
            $handler = new ShowTextBlobHandler($this->dataset, $this, 'public_activity_edm_resultGrid_c_city_handler_view', $column);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."tariff_edm_config"');
            $lookupDataset->addFields(
                array(
                    new IntegerField('id', true, true, true),
                    new StringField('period'),
                    new StringField('action_type'),
                    new StringField('data_type'),
                    new StringField('inclusion'),
                    new StringField('exclusion'),
                    new StringField('tariff'),
                    new IntegerField('quantity_percent'),
                    new IntegerField('quantity'),
                    new StringField('remark'),
                    new StringField('origin_gln'),
                    new StringField('disposition_gln'),
                    new StringField('waste_gtin'),
                    new IntegerField('multiply'),
                    new StringField('o_street'),
                    new StringField('o_street_extension'),
                    new StringField('o_country'),
                    new StringField('o_zip'),
                    new StringField('o_city'),
                    new StringField('d_street'),
                    new StringField('d_street_extension'),
                    new StringField('d_country'),
                    new StringField('d_zip'),
                    new StringField('d_city'),
                    new StringField('o_name'),
                    new StringField('d_name'),
                    new StringField('report_gln'),
                    new StringField('zip_inclusion'),
                    new StringField('zip_exclusion'),
                    new StringField('cat_inclusion'),
                    new StringField('cat_exclusion')
                )
            );
            $lookupDataset->setOrderByField('id', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'edit_public_activity_edm_result_cfg_rule_search', 'id', 'id', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."tariff_edm_activity_types"');
            $lookupDataset->addFields(
                array(
                    new StringField('activity_type', true, true),
                    new StringField('description')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'edit_public_activity_edm_result_action_type_search', 'activity_type', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qwaste_catalog"');
            $lookupDataset->addFields(
                array(
                    new StringField('gtin'),
                    new StringField('selector')
                )
            );
            $lookupDataset->setOrderByField('selector', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'edit_public_activity_edm_result_waste_gtin_search', 'gtin', 'selector', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'edit_public_activity_edm_result_origin_gln_search', 'gln', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'edit_public_activity_edm_result_disposition_gln_search', 'gln', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."tariff_edm_config"');
            $lookupDataset->addFields(
                array(
                    new IntegerField('id', true, true, true),
                    new StringField('period'),
                    new StringField('action_type'),
                    new StringField('data_type'),
                    new StringField('inclusion'),
                    new StringField('exclusion'),
                    new StringField('tariff'),
                    new IntegerField('quantity_percent'),
                    new IntegerField('quantity'),
                    new StringField('remark'),
                    new StringField('origin_gln'),
                    new StringField('disposition_gln'),
                    new StringField('waste_gtin'),
                    new IntegerField('multiply'),
                    new StringField('o_street'),
                    new StringField('o_street_extension'),
                    new StringField('o_country'),
                    new StringField('o_zip'),
                    new StringField('o_city'),
                    new StringField('d_street'),
                    new StringField('d_street_extension'),
                    new StringField('d_country'),
                    new StringField('d_zip'),
                    new StringField('d_city'),
                    new StringField('o_name'),
                    new StringField('d_name'),
                    new StringField('report_gln'),
                    new StringField('zip_inclusion'),
                    new StringField('zip_exclusion'),
                    new StringField('cat_inclusion'),
                    new StringField('cat_exclusion')
                )
            );
            $lookupDataset->setOrderByField('id', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'multi_edit_public_activity_edm_result_cfg_rule_search', 'id', 'id', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."tariff_edm_activity_types"');
            $lookupDataset->addFields(
                array(
                    new StringField('activity_type', true, true),
                    new StringField('description')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'multi_edit_public_activity_edm_result_action_type_search', 'activity_type', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."qwaste_catalog"');
            $lookupDataset->addFields(
                array(
                    new StringField('gtin'),
                    new StringField('selector')
                )
            );
            $lookupDataset->setOrderByField('selector', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'multi_edit_public_activity_edm_result_waste_gtin_search', 'gtin', 'selector', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'multi_edit_public_activity_edm_result_origin_gln_search', 'gln', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
            
            $lookupDataset = new TableDataset(
                PgConnectionFactory::getInstance(),
                GetConnectionOptions(),
                '"public"."contact_edm_gln"');
            $lookupDataset->addFields(
                array(
                    new StringField('gln', true, true),
                    new StringField('type'),
                    new StringField('description'),
                    new StringField('location_gln'),
                    new StringField('site_gln'),
                    new StringField('method_gln'),
                    new StringField('method_text'),
                    new StringField('origin_person'),
                    new StringField('origin_location'),
                    new StringField('origin_site'),
                    new StringField('destination_person'),
                    new StringField('destination_location'),
                    new StringField('destination_site'),
                    new StringField('action_gln'),
                    new StringField('street'),
                    new StringField('street_extension'),
                    new StringField('country'),
                    new StringField('zip'),
                    new StringField('city'),
                    new StringField('origin_single_msg_type')
                )
            );
            $lookupDataset->setOrderByField('description', 'ASC');
            $handler = new DynamicSearchHandler($lookupDataset, $this, 'multi_edit_public_activity_edm_result_disposition_gln_search', 'gln', 'description', null, 20);
            GetApplication()->RegisterHTTPHandler($handler);
        }
       
        protected function doCustomRenderColumn($fieldName, $fieldData, $rowData, &$customText, &$handled)
        { 
    
        }
    
        protected function doCustomRenderPrintColumn($fieldName, $fieldData, $rowData, &$customText, &$handled)
        { 
    
        }
    
        protected function doCustomRenderExportColumn($exportType, $fieldName, $fieldData, $rowData, &$customText, &$handled)
        { 
    
        }
    
        protected function doCustomDrawRow($rowData, &$cellFontColor, &$cellFontSize, &$cellBgColor, &$cellItalicAttr, &$cellBoldAttr)
        {
    
        }
    
        protected function doExtendedCustomDrawRow($rowData, &$rowCellStyles, &$rowStyles, &$rowClasses, &$cellClasses)
        {
    
        }
    
        protected function doCustomRenderTotal($totalValue, $aggregate, $columnName, &$customText, &$handled)
        {
    
        }
    
        protected function doCustomDefaultValues(&$values, &$handled) 
        {
    
        }
    
        protected function doCustomCompareColumn($columnName, $valueA, $valueB, &$result)
        {
    
        }
    
        protected function doBeforeInsertRecord($page, &$rowData, $tableName, &$cancel, &$message, &$messageDisplayTime)
        {
    
        }
    
        protected function doBeforeUpdateRecord($page, $oldRowData, &$rowData, $tableName, &$cancel, &$message, &$messageDisplayTime)
        {
    
        }
    
        protected function doBeforeDeleteRecord($page, &$rowData, $tableName, &$cancel, &$message, &$messageDisplayTime)
        {
    
        }
    
        protected function doAfterInsertRecord($page, $rowData, $tableName, &$success, &$message, &$messageDisplayTime)
        {
    
        }
    
        protected function doAfterUpdateRecord($page, $oldRowData, $rowData, $tableName, &$success, &$message, &$messageDisplayTime)
        {
    
        }
    
        protected function doAfterDeleteRecord($page, $rowData, $tableName, &$success, &$message, &$messageDisplayTime)
        {
    
        }
    
        protected function doCustomHTMLHeader($page, &$customHtmlHeaderText)
        { 
    
        }
    
        protected function doGetCustomTemplate($type, $part, $mode, &$result, &$params)
        {
    
        }
    
        protected function doGetCustomExportOptions(Page $page, $exportType, $rowData, &$options)
        {
    
        }
    
        protected function doFileUpload($fieldName, $rowData, &$result, &$accept, $originalFileName, $originalFileExtension, $fileSize, $tempFileName)
        {
    
        }
    
        protected function doPrepareChart(Chart $chart)
        {
    
        }
    
        protected function doPrepareColumnFilter(ColumnFilter $columnFilter)
        {
    
        }
    
        protected function doPrepareFilterBuilder(FilterBuilder $filterBuilder, FixedKeysArray $columns)
        {
    
        }
    
        protected function doGetSelectionFilters(FixedKeysArray $columns, &$result)
        {
    
        }
    
        protected function doGetCustomFormLayout($mode, FixedKeysArray $columns, FormLayout $layout)
        {
    
        }
    
        protected function doGetCustomColumnGroup(FixedKeysArray $columns, ViewColumnGroup $columnGroup)
        {
    
        }
    
        protected function doPageLoaded()
        {
    
        }
    
        protected function doCalculateFields($rowData, $fieldName, &$value)
        {
    
        }
    
        protected function doGetCustomPagePermissions(Page $page, PermissionSet &$permissions, &$handled)
        {
    
        }
    
        protected function doGetCustomRecordPermissions(Page $page, &$usingCondition, $rowData, &$allowEdit, &$allowDelete, &$mergeWithDefault, &$handled)
        {
    
        }
    
    }

    SetUpUserAuthorization();

    try
    {
        $Page = new public_activity_edm_resultPage("public_activity_edm_result", "frmActivity_edm_result_base.php", GetCurrentUserPermissionSetForDataSource("public.activity_edm_result"), 'UTF-8');
        $Page->SetRecordPermission(GetCurrentUserRecordPermissionsForDataSource("public.activity_edm_result"));
        GetApplication()->SetMainPage($Page);
        GetApplication()->Run();
    }
    catch(Exception $e)
    {
        ShowErrorPage($e);
    }
	
