<!doctype html>
<?php
include('./include/config.inc.php');

if(!hasPermission("action_exit"))
{
	header('Location: index.php');
	die;
}

?>
<html>
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="user-scalable=no, initial-scale=1, maximum-scale=1, minimum-scale=1, width=device-width">
	<meta name="mobile-web-app-capable" content="yes">
	<meta name="apple-mobile-web-app-capable" content="yes">
	<meta http-equiv="X-UA-Compatible" content="IE=edge"/>	
	<title>Waste Management System</title>
	<link rel="shortcut icon" href="favicon.ico">
	<link rel="stylesheet" href="css/jquery.mobile.structure.css">
	<link rel="stylesheet" href="css/jquery.mobile.theme.css">
	<link rel="stylesheet" href="css/jquery.mobile.icons.css">
	<link rel="stylesheet" href="css/wms.css">
	<link rel="stylesheet" href="css/wms.add.css">
	<script src="js/jquery.js"></script>
	<script src="js/jquery.mobile.js"></script>
	<script src="js/wms.js"></script>	
	<script>
		$( document ).on( "click", ".show-page-loading-msg", function() {
			$("#report").fadeOut();
			var $this = $( this ),
				theme = $this.jqmData( "theme" ) || $.mobile.loader.prototype.options.theme,
				msgText = $this.jqmData( "msgtext" ) || $.mobile.loader.prototype.options.text,
				textVisible = $this.jqmData( "textvisible" ) || $.mobile.loader.prototype.options.textVisible,
				textonly = !!$this.jqmData( "textonly" );
				html = $this.jqmData( "html" ) || "";
			$.mobile.loading( "show", {
					text: msgText,
					textVisible: textVisible,
					theme: theme,
					textonly: textonly,
					html: html
			});			
		})
		.on( "click", ".hide-page-loading-msg", function() {
			$.mobile.loading( "hide" );
		});
	</script>
</head>
<body>

<div data-role="page">
	<?php
	include('js/header.php');
	?>
	<?php
	include('js/menu.php');
	?>
	<div role="main" class="ui-content">
		<?php
		
		if (isset($_GET['printonly']))
		{
			$printonly = 'yes';
		}
		else
		{
			$printonly = 'no';
		}
		
		if (isset($_GET['printcopy']))
		{
			$printcopy = 'yes';
		}
		else
		{
			$printcopy = 'no';
		}		
		
		$rep = pg_query($db, 'select field from preset where section = \'report\' and param = \'delivery\'');
		$reprow = pg_fetch_assoc($rep);		
		
		$res = pg_query($db, 'select 
				a.delivery_year, 
				a.delivery_nr, 
				a.contact, 
				a.reference, 
				a.paymenttype,
				p.debitor as pdeb,
				a.remark as remark
			from 
				activity a, 
				paymenttype p
			where
				a.paymenttype = p.id and
				a.id = '.$_GET['id']);
		$row = pg_fetch_assoc($res);
		
		$gsql = pg_query($db, "
				select 
					sum(gross_amount) as amount 
				from 
					activity 
				where 
					delivery_year = '" . $row['delivery_year'] . "' and
					delivery_nr = '" . $row['delivery_nr'] . "'
		");
		
		$grow = pg_fetch_assoc($gsql);
		$amount = $grow['amount'];
		
		echo "Gesamtbetrag Lieferschein Brutto: " . $amount . "<br>";

		$repclsql = pg_query($db, "
		            select 
		                a.id,
		                t.report_class
		            from 
		                activity a,
		                tariff t
				    where 
					    a.delivery_year = '" . $row['delivery_year'] . "' and
					    a.delivery_nr = '" . $row['delivery_nr'] . "' and
					    a.tariff = t.id		
		");

        while ($repclrow = pg_fetch_assoc($repclsql)) {
            if ($repclrow['report_class'] !== NULL) {
                echo "<br><a href='list_pdfform_fill.php?fb=" . $repclrow['report_class'] . "&id=" . $repclrow['id'] . "' target='_blank'>Formular " . $repclrow['report_class'] . " für " . $repclrow['id'] . " ausfüllen ...</a><br>";
            }
        }
		
		?>
		<p>Lieferscheindruck zu Lieferschein <?php echo $row['delivery_year'].'/'.$row['delivery_nr']; ?>!</p>
		
		<form id="report" data-ajax="false" name="report" action="print_render.php?printcopy=<?php echo $printcopy; ?>&printonly=<?php echo $printonly; ?>" method="POST">
		<input type="hidden" name="report" value="<?php echo $reprow['field']; ?>">

		<?php
		
			$prn_select = pg_query($db, 'select field from preset where section = \'report\' and param = \'printer_select\'');
			$rec_select = pg_fetch_assoc($prn_select);		
		
  			echo '<input type="hidden" name="prmYear" value="'.$row['delivery_year'].'">';
  			echo '<input type="hidden" name="prmNr" value="'.$row['delivery_nr'].'">';
  			echo '<input type="hidden" name="followup" value="wms_invoice">';
  			echo '<input type="hidden" name="contact" value="'.$row['contact'].'">';
  			echo '<input type="hidden" name="reference" value="'.$row['reference'].'">';
  			echo '<input type="hidden" name="id" value="'.$_GET['id'].'">';
  			
  			$prnsel = $rec_select['field'];
  			
  			if (($row['pdeb'] <> '') and ($amount <> 0))
  			{
  				$prnsel = str_replace('selected', '', $prnsel);
  				$prnsel = str_replace('value="kein"', 'selected value="kein"', $prnsel);
  			}
  			
  			echo $prnsel;
  			
  			if (substr($row['remark'], 0, 6) <> 'Storno')
  			{  			
  				echo '<input type="text" name="remark" value="'.$row['remark'].'" placeholder="Bemerkung">';
  			}

            $mail_select = pg_query($db, 'select email2 from contact where id = \'' . $row['contact'] . '\'' );
            $mail_rec = pg_fetch_assoc($mail_select);

        ?>


        <input id="email_ls" type="text" name="email_ls" value="<?php echo $mail_rec['email2']; ?>" placeholder="Mailadresse für LS Versand">

		<input id="submit" type="submit" data-textonly="false" data-textvisible="true" data-msgtext="Lieferschein wird gedruckt! Bitte warten ..." class="show-page-loading-msg ui-shadow ui-btn ui-corner-all" value="Weiter">
		
		</form>
		<br>
		<?php
		if(hasPermission("action_storno"))
		{
			if (isset($_GET['storno']))
			{
				if ($_GET['storno'] == 'yes')
				{
			?>
					<a class="ui-btn ui-corner-all" href="action_storno.php?delivery_year=<?php echo $row['delivery_year']; ?>&delivery_nr=<?php echo $row['delivery_nr']; ?>" data-ajax="false"><b>Storno</b></a>
			<?php
				}
			}
		}
		?>			
		 
	</div>
	
	<?php
	include('js/footer.php');
	?>

</div>

</body>
</html>
