<!doctype html>
<?php
include('./include/config.inc.php');

if(!hasPermission("list_pdfform"))
{
	header('Location: index.php');
	die;
}

?>
<html>
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="user-scalable=no, initial-scale=1, maximum-scale=1, minimum-scale=1, width=device-width">
	<meta name="mobile-web-app-capable" content="yes">
	<meta name="apple-mobile-web-app-capable" content="yes">
	<meta http-equiv="X-UA-Compatible" content="IE=edge"/>	
	<title>Waste Management System</title>
	<link rel="shortcut icon" href="favicon.ico">
	<link rel="stylesheet" href="css/jquery.mobile.structure.css">
	<link rel="stylesheet" href="css/jquery.mobile.theme.css">
	<link rel="stylesheet" href="css/jquery.mobile.icons.css">
	<link rel="stylesheet" href="css/wms.css">
	<link rel="stylesheet" href="css/wms.add.css">
	<script src="js/jquery.js"></script>
	<script src="js/jquery.mobile.js"></script>
	<script src="js/wms.js"></script>	
	<script src="js/pdf.js"></script>	
</head>
<body>

<div data-role="page">

	<?php
	include('js/header.php');
	?>
	<?php
	include('js/menu.php');
	?>
		
	<div role="main" class="ui-content">
	
		<h4>
		Daten erfassen für Formblatt <?php echo $_GET['fb']; ?>
		</h4>	
		
		<a class="href ui-shadow ui-btn ui-corner-all" data-ajax="false" href="list_pdfform.php">
		zurück
		</a>
			
		<?php

        if (isset($_GET['id']))
        {
            $data_select = pg_query($db, "
            select 
                a.id,
                t.description as tarif,
                to_char(a.quantity, '99999') as quantity,
                d.description as cname,
                d.street || ', ' || d.zip || ' ' || d.city as caddr,
                c .gln as gln
            from 
                activity a,
                contact c,
                card d,
                tariff t
            where 
                a.contact = c.id and a.card = d.id and t.id = a.tariff and
                a.id = " . $_GET['id']);
            $data = pg_fetch_assoc($data_select);
        }
		
		$prn_select = pg_query($db, 'select field from preset where section = \'report\' and param = \'printer_select\'');
		$rec_select = pg_fetch_assoc($prn_select);
		$prnsel = $rec_select['field'];

        $sql = 'select field from preset where section = \'database\' and param = \'content\'';
        $qry = pg_query($sql);
        $ret = pg_fetch_array($qry);
        $content = $ret['field'];
        if ($content === '')
        {
            $content = 'content';
        }
		
		$fb = $_GET['fb'];
		exec('pdftk "' . realpath("/" . $content . "/FB/".$fb) . '" dump_data_fields_utf8', $output, $retval);
		array_push ( $output , "---" );
		?>
		
		<form id="myform" data-ajax="false" action="./list_pdfform_save.php" method="POST" autocomplete="off">
		
		<input type="hidden" name="fb" id="fb" value="<?php echo $fb; ?>">
		
		<?php

		echo $prnsel;
		
		$field_num = -1;
		
		foreach ($output as &$value) {
			
			if (substr($value, 0, 9) == '---') {
				
				if ($field_num >= 0)
				{
					if ($ftype == "Button") echo '<label>';
					echo '<input ';
					if ($ftype == "Button") echo ' type="checkbox" ';

					if (isset($data))
                    {
                        if ($fname == 'Abfallmasse')
                            echo 'id="' . $field_num . '" name="' . $field_num . '" placeholder="' . $fname . '" value="' . $data['quantity'] . '">';
                        else if ($fname == 'Eindeutige Kennung')
                            echo 'id="' . $field_num . '" name="' . $field_num . '" placeholder="' . $fname . '" value="' . $data['id'] . '">';
                        else if ($fname == 'Begleitscheinnummer')
                            echo 'id="' . $field_num . '" name="' . $field_num . '" placeholder="' . $fname . '" value="' . $data['id'] . '">';
                        else if ($fname == 'Abfallbesitzer - Firmenname')
                            echo 'id="' . $field_num . '" name="' . $field_num . '" placeholder="' . $fname . '" value="' . $data['cname'] . '">';
                        else if ($fname == 'Abfallbesitzer - Anschrift')
                            echo 'id="' . $field_num . '" name="' . $field_num . '" placeholder="' . $fname . '" value="' . $data['caddr'] . '">';
                        else if ($fname == 'Abfallbesitzer - PersonenGLN')
                            echo 'id="' . $field_num . '" name="' . $field_num . '" placeholder="' . $fname . '" value="' . $data['gln'] . '">';
                        else if ($fname == 'TAG ' . $data['tarif'])
                            echo 'id="' . $field_num . '" name="' . $field_num . '" placeholder="' . $fname . '" checked>';
                        else
                            echo 'id="' . $field_num . '" name="' . $field_num . '" placeholder="' . $fname . '">';
                    }
					else
                    {
                        echo 'id="' . $field_num . '" name="' . $field_num . '" placeholder="' . $fname . '">';
                    }

					if ($ftype == "Button") echo $fname;
					if ($ftype == "Button") echo '</label>';
					echo "\r\n"; 
				}
					
				$field_num++;
				$ftype = "";
				$fname = "";
				$fopt = "";
				
			}			
			
			if (substr($value, 0, 9) == 'FieldName') {
				$fname = substr($value, 11);
			}
			if (substr($value, 0, 9) == 'FieldType') {
				$ftype = substr($value, 11);
			}
			if (substr($value, 0, 16) == 'FieldStateOption') {
				$fopt = substr($value, 18);
			}
			
		}
		
		?>
		
		<input id="submit" type="submit" class="ui-shadow ui-btn ui-corner-all" data-icon="action" data-iconpos="top" value="Speichern">
		
		</form>
					
	</div>

	<?php
	include('js/footer.php');
	?>
			
</div>

</body>
</html>
