<!doctype html>
<?php
include('./include/config.inc.php');

if(!hasPermission("list_tariff"))
{
	header('Location: index.php');
	die;
}

?>
<html>
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="user-scalable=no, initial-scale=1, maximum-scale=1, minimum-scale=1, width=device-width">
	<meta name="mobile-web-app-capable" content="yes">
	<meta name="apple-mobile-web-app-capable" content="yes">
	<meta http-equiv="X-UA-Compatible" content="IE=edge"/>	
	<title>Waste Management System</title>
	<link rel="shortcut icon" href="favicon.ico">
	<link rel="stylesheet" href="css/jquery.mobile.structure.css">
	<link rel="stylesheet" href="css/jquery.mobile.theme.css">
	<link rel="stylesheet" href="css/jquery.mobile.icons.css">
	<link rel="stylesheet" href="css/wms.css">
	<link rel="stylesheet" href="css/wms.add.css">
	<script src="js/jquery.js"></script>
	<script src="js/jquery.mobile.js"></script>
	<script src="js/wms.js"></script>	
</head>
<body>

<div data-role="page">

	<?php
	include('js/header.php');
	?>
	<?php
	include('js/menu.php');
	?>
		
	<div role="main" class="ui-content">
		
		<ul data-role="listview" data-inset="true" data-filter="true" data-filter-placeholder="Tarifsuche ...">				
		<?php
		
			$cat = pg_query($db, 'select category.description as cat, category.id as id, count(category.description) as cnt from tariff, category where tariff.category = category.id group by category.description, category.id order by category.description');
			
			while ($cow = pg_fetch_assoc($cat)) {
			?>
						
				<li data-role="list-divider"><?php echo $cow['cat']; ?><span class="ui-li-count"><?php echo $cow['cnt']; ?></span></li>
			
				<?php 
		
				$res = pg_query($db, 'select t.description, t.id, t.unit, p.description as pricetable, p.id as pid, t.sales, t.remark, p.currency from tariff t, pricetable p where t.pricetable = p.id and category = \''.$cow['id'].'\' order by description');
				while ($row = pg_fetch_assoc($res)) {
				
					?>
					
					<li>
					<a class="href" href="#">
					<h2><?php echo $row['description']; ?></h2>
					<p>
					Nummer: <?php echo $row['id']; ?><br>
					Einheit: <?php echo $row['unit']; ?><br>
					Preistabelle: <?php echo $row['pricetable'].' in '.$row['currency']; ?><br>
					Verkauf: <?php if ($row['sales'] == 1) { echo 'ja'; } else { echo 'nein'; } ?><br>
					<br>
					<?php echo $row['remark']; ?>
					
					<?php

					$pri = pg_query($db, 'select to_char(price, \'9G990D00\') as price, valid_from, valid_to from pricetable_entry where pricetable = \''.$row['pid'].'\' order by valid_from desc');
					while ($pow = pg_fetch_assoc($pri)) {
					?>
					
					Preis <?php echo '€ '.$pow['price']; ?> gültig von <?php echo $pow['valid_from']; ?> bis <?php echo $pow['valid_to']; ?><br>
					
					<?php 
					}
					
					?>
					
					</p>
					</a>
					</li>
			
					<?php 
							
				}
				
			}
						
		?>
		</ul>
					
	</div>

	<?php
	include('js/footer.php');
	?>
			
</div>

</body>
</html>
